/*-------------------------------------------------------------------------------------------------------
ϸ : talk_server.c
   : ũ Ŭ̾Ʈ 1:1  Ѵ
 : cc -o talk_server talk_server.c -lsocket                   
 : talk_server 3000
--------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAXLINE 512

char *escapechar = "exit";		/* Ṯ */

int main(int argc, char *argv[]) {
   int server_fd, client_fd;		/* Ϲȣ */
   int clilen, num;
   char sendline[MAXLINE], recvline[MAXLINE];
   int size;
   pid_t pid;
   struct sockaddr_in client_addr, server_addr;
   
   if (argc != 2)  {
      printf(": %s port\n", argv[0]);
      exit(0);
   }

   /*   */
   if((server_fd=socket(PF_INET, SOCK_STREAM, 0)) < 0) {
      printf("Server: Can't open stream socket\n");
      exit(0);
   }
   
   /*  ּ ü server_addr '0' ʱȭ */
   bzero((char *)&server_addr, sizeof(server_addr));
   
   /* server_addr  */
   server_addr.sin_family = AF_INET;
   server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   server_addr.sin_port = htons(atoi(argv[1]));
   /* bind() ȣ */
   if(bind(server_fd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
      printf("Server: Can't bind local address \n");
      exit(0);
   }
   
   printf("Server started.\nWaiting for client..\n");
   listen(server_fd, 1);
         
   /* Ŭ̾Ʈ û  */
   clilen = sizeof(client_addr);
   if((client_fd = accept(server_fd,(struct sockaddr *)&client_addr, &clilen)) < 0) {
      printf("Server: failed in accepting.\n");
      exit(0);
   }
   
   if(( pid = fork()) > 0)  {
      /* θ μ Ű Է   */
      while(fgets(sendline, MAXLINE, stdin) != NULL)  {
        size = strlen(sendline);
	     	if(write(client_fd, sendline, strlen(sendline)) != size) printf("Error in write\n");
	     	/* Ṯڿ Է ó */
        	if (strstr(sendline, escapechar) != NULL ) {
				printf("Good bye.\n");
           	close(client_fd);
				exit(0);
        	}
      }
   } else if (pid == 0) {
      /* ڽ μ κ  ޽ ȭ鿡  */
      while(1) {
	   		if((size = read(client_fd, recvline, MAXLINE)) < 0) {
				printf("Error if read\n");
        		close(client_fd);
				exit(0);
			}
	      	recvline[size] =  '\0';
        	/* Ṯڿ Ž  */
	      	if (strstr(recvline, escapechar) != NULL )  break;
			/* ȭ  */
	      	printf("%s", recvline);
		}
	}
  close(server_fd);
  close(client_fd);
}
