// ϸ: JavaChatServer.java
//   : ڹ  ̿ ä 
// : javac JavaChatServer.java
// : java JavaChatServer 3000

import java.io.*;
import java.net.*;
import java.util.Vector;

public class JavaChatServer {
	ServerSocket ss = null;					//  
	Socket s = null;							// Ŭ̾Ʈ 
	Vector client = new ();
		
	public static void main(String[] args) {
		new JavaChatServer(args);
	}
		
	// 
	JavaChatServer(String[] args) {
		try {
			ss = new ServerSocket(Integer.parseInt(args[0]));
		} catch(IOException e) {
			System.out.println("Can't make ServerSocket");
		}
		System.out.println("Java Chat Server started. Accepting the client ...");

		try {
			while(true) {
					s = ss.accept();
					//    
					ManageClient  m = new ManageClient(s);	
					client.addElement(m);
					System.out.println("New Client ! Number of client  = " + (client.size() ));
					//   
					m.start();																	
			}
		} catch(IOException e) { }
	}
	
	//    (Ŭ)
	class ManageClient extends Thread { 
		Socket s;
		DataInputStream dis;
		DataOutputStream dos;
		// 
		public ManageClient(Socket s) {
			this.s = s;
			try {
				dis = new DataInputStream(s.getInputStream());
				dos = new DataOutputStream(s.getOutputStream());
			} catch(IOException e) {
				System.out.println("Can't make stream");
			}
		}

		// run() ޼ҵ
		public void run() {
			String msg;
			while(true) {
				try {
					msg = dis.readUTF();
				} catch(IOException e) {
					System.out.println("Reading error for a client. (Could be logout)");
					exitClient(this);
					return;
				}
				int index = msg.indexOf("BYE");
				if(index >= 0) {
					broadcast(msg.substring(0, index) + " ä մϴ.");
					exitClient(this);				// ä Ż ó
					return;							// run() ޼ҵ 
				} else {
					broadcast(msg);				//  Ŭ̾Ʈ ޽ 
				}
				yield();								// ٸ 忡  纸
			}
		}
	}
		
	//  Ŭ̾Ʈ ޽ ϴ ޼ҵ
	public void broadcast(String msg) {
		int numOfConnect = client.size();
		for(int i = 0; i < numOfConnect; i++) {
			try {
				ManageClient m = (ManageClient) client.elementAt(i);
				m.dos.writeUTF(msg);
				m.dos.flush();
			} catch(IOException e) {
				System.out.println("broadcast() error.");
			}
		}
	}

	// Ŭ̾Ʈ Ż  ȣǴ ޼ҵ
	public void exitClient(ManageClient c) {
		int i = client.indexOf(c);
		if (i >= 0) {
			client.removeElementAt(i);
				try {
					if(c.dis != null) c.dis.close();
					if(c.dos != null) c.dos.close();
					if(c.s != null) c.s.close();
				} catch(IOException e) {
					System.out.println("IOException error");
				}
				System.out.println("A Client exited! Number of client= "+ client.size());
		} else {
				System.out.println("No such a client in Server! ");
		}
	}
}


