// ϸ: RMIChatClient.java
//   : RMI ̿ ä Ŭ̾Ʈ
// : javac RMIChatClient.java,  rmic RMIChatClient
// : appletviewer RMIChatClient.html

import java.applet.Applet;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.Serializable;
import java.net.URL;
import java.util.*;
import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

public class RMIChatClient extends Applet implements RMIChatClientInterface {
	RMIChatServerInterface Server;		//  ä ü
	Button connect, disconnect;			// ,  ư
	TextArea memo;							// ä â
	TextField name;							// ä  ̸
	TextField field;							// ä ޽ Է â
	boolean connect_flag = false;			//    ÷
	
	// ø init() ޼ҵ
	public void init() {
		// ̸, , Ż ư
		Panel p = new Panel();
		Label label = new Label("My Name:");
		name = new TextField("noname");
		connect = new Button("Connect");
		// ڽ(this)  ڷ Ѱش
		connect.addActionListener(new ConnectListener(this)); 
		disconnect = new Button("Disconnect");
		disconnect.addActionListener(new DisconnectListener(this)); 
		p.add(label);
		p.add(name);
		p.add(connect);
		p.add(disconnect);
		
		// ޽  â
		memo = new TextArea();
		memo.setEditable(false);			//   â 
		field = new TextField();
		field.addActionListener(new SendListener()); 
		setLayout(new BorderLayout());
		add(p, BorderLayout.NORTH);
		add(memo, BorderLayout.CENTER);
		add(field, BorderLayout.SOUTH);
	}
	
	// ø start() ޼ҵ
	public void start() {
		try {
			UnicastRemoteObject.exportObject(this);
			URL base = getDocumentBase();
			String serverName = "//" + base.getHost() + ":"  + "/" + "RMIChatServer";
			Server = (RMIChatServerInterface) Naming.lookup(serverName);
		} catch (Exception e) {
			memo.append("Initializing error: Check server is running\n");
			return;
		}
		memo.append("RMI naming initialized\n");
	}		
	
	// (Connect) ̺Ʈ ó 
	class ConnectListener implements ActionListener {
		RMIChatClientInterface client;
		// 		
		public ConnectListener(RMIChatClientInterface client) {
			this.client = client;
		}
			public void actionPerformed(ActionEvent ae) {
			if(connect_flag == false) {
				try {
					// ڽ ̽ ü ̸   connect() ȣ
					Server.connect(client, name.getText());
					System.out.println("Connected to Chatting Server\n");
				} catch (Exception e) {
					System.out.println("Connect error");
					e.printStackTrace();
					return;
				}
				connect_flag = true;
			} 	else {
				memo.append("You are already connedted\n");		// ߺ  õ ó
			}
		}
	}
	
	// ä ޽ ۽ ó 
	class SendListener implements ActionListener {
		
		public void actionPerformed(ActionEvent ae) {
			try {
				if(connect_flag == true) 
				Server.broadcast(name.getText() + ":" + field.getText());
			} catch (Exception e) {
				System.out.println("Sending error");
				e.printStackTrace();
				return;
			}
			field.setText("");
		}
	}			
	
	// (Disconnect) ư ó 
	class DisconnectListener implements ActionListener {
		RMIChatClientInterface client;
		// 
		public DisconnectListener(RMIChatClientInterface client) {
			this.client = client;
		}
		
		public void actionPerformed(ActionEvent ae) {
			if(connect_flag == true) {
				connect_flag = false;
				try {
					Server.disconnect(client, name.getText());
				} catch (Exception e) {
					System.out.println("Disconnect error");
					e.printStackTrace();
					return;
				}
				memo.append("Disconnected\n");
			} else {
				memo.append("You are already disconnected\n");
			}
		}
	}
	// ޽ ϴ ޼ҵ,  ؼ ȣ ȴ.
	public void displayMessage(String message) throws RemoteException {
		memo.append(message + "\n");
	}
}

